﻿<?php
/******************************************************************
* ePayBank payment                                                *
* http://ePayBank.ir                                              *
* Copyright (c) 2013 ePayBank.ir :: MortezaSaheb                  *
* AUTHOR ePayBank developement team ( support[at]ePayBank[dot]ir )*
******************************************************************/

class osC_Payment_ePayBank extends osC_Payment {
	var $_title, $_code = 'ePayBank', $_status = false, $_sort_order, $_order_id,$go;
    function send($merchentid,$merchentpass,$callbackurl,$amount,$bank,$orderid){
       //============================================================================
require_once "ext/lib/nusoap.php";
$client=new nusoap_client("http://epaybank.ir/secure_gateway/index.php");
$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("requestpayment",array($merchentid,$merchentpass,$callbackurl,$amount,$bank,$orderid));
$client->soap_defencoding = 'UTF-8';
if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error)
	{
		return "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		
		return $result;
		
	}
}
       //==========================================================================

    }
    function get($merchentid,$merchentpass,$amount,$rs,$bank){
        //============================================================
require_once "ext/lib/nusoap.php";
$client=new nusoap_client("http://epaybank.ir/secure_gateway/index.php");
$client->soap_defencoding = 'UTF-8';

$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("verifypeyment",array($merchentid,$merchentpass,$amount,$rs,$bank));
$client->soap_defencoding = 'UTF-8';

if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error){
		return "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		//echo "<h2>Result</h2><pre>";
		return $result;
		//echo "</pre>";
	}
}

	//========================================================
    
    }
	function osC_Payment_ePayBank() {
		global $osC_Database, $osC_Language, $osC_ShoppingCart,$amount;
		$this->_title = $osC_Language->get('پرداخت اينترنتي ePayBank');
		$this->_method_title = $osC_Language->get('پرداخت اينترنتي ePayBank');
		$this->_status = (MODULE_PAYMENT_ePayBank_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_ePayBank_SORT_ORDER;
		
		if ($this->_status === true) {
			if ((int) MODULE_PAYMENT_ePayBank_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_ePayBank_ORDER_STATUS_ID;
			}
			if ((int) MODULE_PAYMENT_ePayBank_ZONE > 0) {
				$check_flag = false;
				$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
				$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
				$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_ePayBank_ZONE);
				$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
				$Qcheck->execute();
				while ($Qcheck->next()) {
					if ($Qcheck->valueInt('zone_id') < 1) {
						$check_flag = true;
						break;
					}
					elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id')) {
						$check_flag = true;
						break;
					}
				}
				if ($check_flag === false) {
					$this->_status = false;
				}
			}
		}
	}
	function selection() {
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}
	function pre_confirmation_check() {
		return false;
	}
	function confirmation() {
		global $osC_Language, $osC_CreditCard;
		$this->_order_id = osC_Order :: insert(ORDERS_STATUS_PREPARING);
		$confirmation = array('title' => $this->_method_title, 'fields' => array(array('title' => $osC_Language->get('پرداخت آنلاین با ePayBank.ir '))));
		return $confirmation;
	}
	function process_button() {
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		if (MODULE_PAYMENT_ePayBank_CURRENCY == 'Selected Currency') {
			$currency = $osC_Currencies->getCode();
		}
		else {
			$currency = MODULE_PAYMENT_ePayBank_CURRENCY;
		}
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$order = $this->_order_id;
		$amount = $amount;
		$orderId = $order;
		$status = 1;
		$callbackUrl = urlencode(osc_href_link(FILENAME_CHECKOUT, 'process', 'HTTP', null, null, true));
$callbackUrl2 = osc_href_link(FILENAME_CHECKOUT, 'process', 'HTTP', null, null, true);
	
        $merchentid = MODULE_PAYMENT_ePayBank_PIN;
        $merchentpass=MODULE_PAYMENT_ePayBank_PASS;

		$result = $this->send($merchentid,$merchentpass,$callbackUrl2,$amount,"parsian",$orderId);
        //$go = $result;
        if(filter_var($result, FILTER_VALIDATE_URL)){//agar url bashad

		    $osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "online_transactions`(orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values('$order','$result','ePayBank','','$amount','')");
			//
			echo '<div style="text-align:left;">' . osc_link_object(osc_href_link( $result, '', '', '', false), osc_draw_image_button('button_confirm_order.gif', $osC_Language->get('button_confirm_order'), 'id="btnConfirmOrder"')) . '</div><div style="display:none">';
		}
		else {
		    // log error in app
			// Update table, log the error
			osC_Order :: remove($this->_order_id);
			echo '<div style="font-size:11px; color:#cc0000; width:500; border:1px solid #cc0000; padding:5px; background:#ffffcc;">' . check_ePayBank_state_error($result) . '</div><div style="display:none">';
		}

	}
	function get_error() {
		global $osC_Language;
		return $error;
	}
	function process() {
		global $osC_Language, $osC_Customer, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
      
       $merchentid = MODULE_PAYMENT_ePayBank_PIN;
        $merchentpass=MODULE_PAYMENT_ePayBank_PASS;
        //$amount
        $id_get = $_GET['rs'];
        $result = $this->get($merchentid,$merchentpass,$amount, $id_get ,"parsian");
        if($result == '-33'){
		    $osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "online_transactions` set transaction_id = '$trans_id',transaction_date = '" . date("YmdHis") . "' where 1 and ( receipt_id = '$id_get' )");

			$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
			$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
			$Qtransaction->bindInt(':orders_id', $order);
			$Qtransaction->bindInt(':transaction_code', 1);
			$Qtransaction->bindValue(':transaction_return_value', $id_get);
			$Qtransaction->bindInt(':transaction_return_status', 1);
			$Qtransaction->execute();
			//
			$this->_order_id = osC_Order :: insert();
			 $comments = $osC_Language->get('payment_ePayBank_method_refid') . '[' . $id_get .']';

                        osC_Order::process($this->_order_id, $this->order_status, $comments);
		}
		else {
	        $order = $this->_order_id;
			$orderid = $order;
			$reversaltoreversal = $order;
			$reversalstatus = 1;
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1 and ( receipt_id = '$id_get' ) and ( orders_id = '$order' )");
			//
			osC_Order :: remove($this->_order_id);
			$messageStack->add_session('checkout', 'خطا در تایید تراکنش ، مبلغ تراکنش با موفقیت به حساب شما برگشت داده شد.', 'error');
			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		    }
								// end Display the result
		}

	function callback() {
		global $osC_Database;
		//
	}
}
function check_ePayBank_state_error($status) {
	switch ($status) {
		case '-1' :
			$pay_error = "api ارسالی با نوع api تعریف شده در ePayBank سازگار نیست.";
			break;
		DEFAULT :
			$pay_error = "خطاي نامشخص [خطاي شماره : $status]";
	}
	return '<b>خطا شماره ' . $status . ' :</b> ' . $pay_error;
}
?>
